package kr.as3.tween
{
	import kr.as3.tween.easing.*;
	
	import flash.display.Sprite;
	
	use namespace prop;
	
	/**
	 * TweenObject
	 *
	 * @author: Yun Jinsang (a.k.a. Wooyaggo, http://www.as3.kr, victim4@gmail.com)
	 * @created: 2008.04.15
	 * 
	 * This source code follow LGPL (Lesser GPL)
	 * 
	 
	 
	 * 본 제품(소프트웨어)는 GPL 라이센스 하에 배포되는 소프트웨어 PresentationKit 을 포함합니다
	 
	 
	 * 
	 * 이 소스코드는 LGPL 을 따릅니다.
	 * 사실 저도 LGPL 을 잘 모릅니다.
	 * 
	 * 하지만 단순한 몇가지를 나열해봅니다.
	 * 
	 * * 라이센시(Licensee)는 오픈소스 소프트웨어(이 컴퍼넌트 클래스)를 자유롭게 사용할 수 있다.
	 * * 라이센시(Licensee)는 오픈소스 소프트웨어(이 컴퍼넌트 클래스)를 일정한 조건하에 자유롭게 복제할 수 있다.
	 * * 라이센시(Licensee)는 오픈소스 소프트웨어(이 컴퍼넌트 클래스)를 일정한 조건하에 자유롭게 수정, 수정된 내용을 재배포할 수 있다.
	 * 
	 * * 복제, 수정, 재배포에 대한 조건 *
	 * * 저작권 관련 문구를 유지한다.
	 * * 제품명 혹은 컴퍼넌트(클래스)명을 중복되지 않게 한다.
	 * * 최종결과물에 사용 여부를 명시한다. (논문의 "인용" 과 비슷)
	 * * 수정, 추가하였을때는 수정, 추가한 소스코드도 공개한다. (저작자에게 email 로 알리면 된다고 봄)
	 * * 특허에 관련될 경우 복잡해지니 무시.
	 * 
	 * 
	 * 간단하게 이야기하면 이 소스는 LGPL 을 따르기 때문에 사용했다는 것을 반드시 밝혀야하고, 
	 * 원본 소스가 수정 또는 추가되면 그 소스도 자동으로 LGPL 을 따르게 된다는 이야기입니다.
	 * 
	 * 더 쉽게 말해서 걍 쓰시고 썼다는 이야기만 해주시면 될거 같습니다. 대부분 수정은 잘 안하자나요 ㅋㅋ
	 * 수정하면 수정했다고 공개하거나 메일로 소스랑 같이 알려주면되는거 같구요.
	 * 생각보다 그렇게 어려운 건 아닌거 같습니다^^
	 * 
	 * 오픈소스 소프트웨어 라이센스 가이드 : http://wiki.kldp.org/wiki.php/OpenSourceLicenseGuide?action=show&redirect=FindPage#s-3.2.2
	 * KLDP 의 LGPL 관련 질문글 : http://search.empas.com/search/oea/kldp/oe.html?q=LGPL&sdsn=&en=utf8
	 * 
	 * 우리 모두 같이 자유롭게 소스를 공개하고 떳떳하게 사용하는 분위기를 조성해봅시다.
	 * 
	 */
	public class TweenObject
	{
		private var tweenData: Object;
		
		public function TweenObject(	x: Object = null, 
													y: Object = null, 
													alpha: Object = null, 
													width: Object = null, 
													height: Object = null, 
													rotation: Object = null, 
													scaleX: Object = null, 
													scaleY: Object = null
													 ): void
		{
			tweenData 					= new Object();
			tweenData.list 				= new Array();
			tweenData.x 				= ( x == null )? new Object() :  				( tweenData.list.push( "x" ), 				x );
			tweenData.y 				= ( y == null )? new Object() :  				( tweenData.list.push( "y" ), 				y );
			tweenData.alpha 			= ( alpha == null )? new Object() :  		(tweenData.list.push( "alpha" ), 		alpha );
			tweenData.width 			= ( width == null )? new Object() :  		( tweenData.list.push( "width" ), 		width );
			tweenData.height 		= ( height == null )? new Object() :  		( tweenData.list.push( "height" ), 		height );
			tweenData.rotation 		= ( rotation == null )? new Object() :  	( tweenData.list.push( "rotation" ), 	rotation );
			tweenData.scaleX 		= ( scaleX == null )? new Object() :  		( tweenData.list.push( "scaleX" ), 		scaleX );
			tweenData.scaleY 		= ( scaleY == null )? new Object() :  		( tweenData.list.push( "scaleY" ), 		scaleY );
		}
		
		prop function get list(): Array			{ return tweenData.list 			};
		prop function get x(): Object				{ return tweenData.x 			};
		prop function get y(): Object				{ return tweenData.y 			};
		prop function get alpha(): Object		{ return tweenData.alpha 		};
		prop function get width(): Object		{ return tweenData.width 		};
		prop function get height(): Object		{ return tweenData.height 	};
		prop function get rotation(): Object	{ return tweenData.rotation 	};
		prop function get scaleX(): Object		{ return tweenData.scaleX 	};
		prop function get scaleY(): Object		{ return tweenData.scaleY 	};
		
		public function x ( sn: Number, en: Number, ease: Array = null ): void
		{
			tweenData.x.p1 = sn;
			tweenData.x.p2 = en;
			tweenData.x.ease = ( ease == null )? TweenNone.none :  ease;
			if( tweenData.list.indexOf( "x", 0 ) == -1 )
			{
				tweenData.list.push( "x" );
			}
		}
		
		public function y ( sn: Number, en: Number, ease: Array = null ): void
		{
			tweenData.y.p1 = sn;
			tweenData.y.p2 = en;
			tweenData.y.ease = ( ease == null )? TweenNone.none :  ease;
			if( tweenData.list.indexOf( "y", 0 ) == -1 )
			{
				tweenData.list.push( "y" );
			}
		}
		
		public function alpha ( sn: Number, en: Number, ease: Array = null ): void
		{
			tweenData.alpha.p1 = sn;
			tweenData.alpha.p2 = en;
			tweenData.alpha.ease = ( ease == null )? TweenNone.none :  ease;
			if( tweenData.list.indexOf( "alpha", 0 ) == -1 )
			{
				tweenData.list.push( "alpha" );
			}
		}
		
		public function width ( sn: Number, en: Number, ease: Array = null ): void
		{
			tweenData.width.p1 = sn;
			tweenData.width.p2 = en;
			tweenData.width.ease = ( ease == null )? TweenNone.none :  ease;
			if( tweenData.list.indexOf( "width", 0 ) == -1 )
			{
				tweenData.list.push( "width" );
			}
		}
		
		public function height ( sn: Number, en: Number, ease: Array = null ): void
		{
			tweenData.height.p1 = sn;
			tweenData.height.p2 = en;
			tweenData.height.ease = ( ease == null )? TweenNone.none :  ease;
			if( tweenData.list.indexOf( "height", 0 ) == -1 )
			{
				tweenData.list.push( "height" );
			}
		}
		
		public function rotation ( sn: Number, en: Number, ease: Array = null ): void
		{
			tweenData.rotation.p1 = sn;
			tweenData.rotation.p2 = en;
			tweenData.rotation.ease = ( ease == null )? TweenNone.none :  ease;
			if( tweenData.list.indexOf( "rotation", 0 ) == -1 )
			{
				tweenData.list.push( "rotation" );
			}
		}
		
		public function scaleX ( sn: Number, en: Number, ease: Array = null ): void
		{
			tweenData.scaleX.p1 = sn;
			tweenData.scaleX.p2 = en;
			tweenData.scaleX.ease = ( ease == null )? TweenNone.none :  ease;
			if( tweenData.list.indexOf( "scaleX", 0 ) == -1 )
			{
				tweenData.list.push( "scaleX" );
			}
		}
		
		public function scaleY ( sn: Number, en: Number, ease: Array = null ): void
		{
			tweenData.scaleY.p1 = sn;
			tweenData.scaleY.p2 = en;
			tweenData.scaleY.ease = ( ease == null )? TweenNone.none :  ease;
			if( tweenData.list.indexOf( "scaleY", 0 ) == -1 )
			{
				tweenData.list.push( "scaleY" );
			}
		}
	}
}